<template>
  <div>
    <div
        v-if="isAuth || confirmTrueCode"
        class="WAL position-relative bg-grey-4"
        :style="style"
        ref="chatContainer"
        @dragenter.prevent="dragEnter"
        @dragover.prevent="dragOver"
    >
      <q-layout
          view="lHh Lpr lFf"
          class="WAL__layout shadow-3"
          container
      >
        <q-header elevated>
          <q-toolbar
              class="bg-grey-3 text-black"
              :class="{'flex flex-wrap': screenWidth <1000}"
          >
            <q-btn
                round
                flat
                icon="keyboard_arrow_left"
                class="WAL__drawer-open q-mr-sm"
                @click="toggleLeftDrawer"
            />

            <q-chip
                @click="getStatus"
                :label="statusLabel"
                :style="{backgroundColor: lead.status?.color, color: '#fff'}"
                :dense="screenWidth <1000"
                :size="screenWidth <650 && 'sm' || 'md'"
                clickable
                :color="lead.status && lead.status.color || 'grey'"
                :class="{'pointer-events-none':!isAuth}"
            >
              <q-menu>
                <q-list style="min-width: 100px">
                  <q-item v-for="(item, index) in status" dense style="min-width: 100px">
                    <q-item-section v-if="item.name !== 'Передан в регион'" clickable v-close-popup class="cursor-pointer" @click="selectStatus(item)">
                      <q-chip :label="item.name" :style="{backgroundColor: item.color, color: '#fff'}" />
                    </q-item-section>
                    <div v-else class="flex align-items-center">
                      <q-item-section clickable class="cursor-pointer">
                        <q-chip :label="item.name" :style="{backgroundColor: item.color, color: '#fff'}" />
                      </q-item-section>
                      <q-item-section side>
                        <q-icon name="keyboard_arrow_right" />
                      </q-item-section>
                      <q-menu anchor="top end" self="top start" auto-close>
                        <q-list>
                          <q-item
                              v-for="(reg, i) in regions"
                              :key="reg._id"
                              dense
                              clickable
                              @click="toRegion(reg._id, i)"
                          >
                            {{reg.name}}
                          </q-item>
                        </q-list>
                      </q-menu>
                    </div>
                  </q-item>
                </q-list>
              </q-menu>
              <q-tooltip>Статус лида</q-tooltip>
            </q-chip>

            <q-separator vertical class="mx-4 my-3"/>
            <span class="q-subtitle-1">
            {{ lead.website || lead.generate }}
            <q-popup-edit v-if="isAuth" v-model="lead.website" >
              <q-input v-model="lead.website" dense autofocus counter />
              <q-btn v-close-popup class="float-right" label="Сохранить" color="green" size="sm" @click="useUpdateLead({_id: lead._id, key: 'website', value: lead.website})"/>
            </q-popup-edit>
            <q-tooltip>Сайт, откуда пришел лид</q-tooltip>
          </span>
            <q-separator vertical class="mx-4 my-3"/>
            <span class="q-subtitle-1">
            <UserSelected
                :model-select="selectedResponsible.username"
                :model-value="selectedResponsible.username && selectedResponsible.username || ''"
                :label-chip="selectedResponsible.username || lead.responsible?.username || 'Указать'"
                color-chip="blue"
                text-color-chip="white"
                :is-chip="false"

                @selectUser="selectResponsible"
                class="block mx-4"
            />
            <q-tooltip>Ответственный</q-tooltip>
          </span>
            <q-separator vertical class="mx-4 my-3"/>
            <div class="q-subtitle-1">
              <p>{{ formattedDate(lead.createdAt) }}</p>
              <q-tooltip>Дата создания лида</q-tooltip>
            </div>

            <q-space/>
            <q-btn round flat icon="more_vert">
              <q-menu auto-close :offset="[150, 0]">
                <q-list>
                  <q-item @click="getHistory" clickable>
                    <q-item-section>История лида</q-item-section>
                  </q-item>
                  <q-item v-if="roleMiddleware(['ADMIN'])" clickable @click="deleteAllMessage">
                    <q-item-section>Удалить сообщения и задачи</q-item-section>
                  </q-item>
                  <q-item clickable @click="deleteStatus">
                    <q-item-section>Удалить статус</q-item-section>
                  </q-item>
                  <q-item v-if="roleMiddleware(['ADMIN'])" clickable @click="deleteLead">
                    <q-item-section>Удалить лид</q-item-section>
                  </q-item>
                </q-list>
              </q-menu>
            </q-btn>
          </q-toolbar>
        </q-header>

        <q-drawer
            v-model="leftDrawerOpen"
            show-if-above
            bordered
            :breakpoint="690"
            :width="390"
        >
          <q-toolbar class="bg-grey-3">
          <span class="text-xl q-pl-md">
            Информация
          </span>

            <q-space />

            <div class="flex column">
              <span class="text-xs">Уникальный № лида</span>
              <q-badge :label="lead._id"/>
            </div>

            <q-btn
                round
                flat
                icon="close"
                class="WAL__drawer-close"
                @click="toggleLeftDrawer"
            />
          </q-toolbar>

          <q-scroll-area style="height: calc(100% - 100px)">
            <q-tabs
                v-model="tab"
                dense
                no-caps
                inline-label
                outside-arrows
                mobile-arrows
                style="max-width: 390px"
            >
              <q-tab name="contacts" icon="call" label="Контакты" />
              <q-tab name="fin" icon="attach_money" label="Финансы" />
              <q-tab name="task" icon="add_task" label="Задачи" />
              <q-tab name="docs" icon="picture_as_pdf" label="Документы" />
              <q-tab name="calendar" icon="calendar_month" label="Календарь" />
              <q-tab name="transfer" icon="add_task" label="Передача" />
            </q-tabs>
            <q-list v-if="tab === 'contacts'">
              <Lead_Fin_Field
                  prefix="Имя:"
                  iconName="person"
                  :model="lead.name"
                  keyObj="name"
                  inputFull
                  @updateField="updateField"
              />
              <Lead_Fin_Field
                  prefix="Телефон:"
                  iconName="call"
                  :model="lead.phone"
                  keyObj="phone"
                  inputFull
                  whatsapp
                  disable
              />
              <Lead_Fin_Field
                  v-show="field.name.toLowerCase().indexOf('телефон') >= 0"
                  v-for="(field, indexField) in lead.fields"
                  :prefix="`${field.name}:`"
                  :model="field"
                  inputFull
                  :whatsapp="field.name.toLowerCase().indexOf('телефон') >= 0"
                  :telegram="field.name.toLowerCase().indexOf('телефон') >= 0"
                  additionalField
                  :type="field.type"
                  :option="field.values"
                  keyObj="fields"
                  :index="indexField"
                  :fields="lead.fields"
                  class="mx-4 pr-4"
                  @updateField="updateField"
                  :mask="field.name.toLowerCase().indexOf('телефон') >= 0 && '###########' || ''"
              />
              <Lead_Fin_Field
                  prefix="Email:"
                  iconName="email"
                  :model="lead.email"
                  keyObj="email"
                  inputFull
                  icon-url="https://e.mail.ru/messages/inbox/"
              />
              <Lead_Fin_Field
                  prefix="Город:"
                  iconName="apartment"
                  :model="lead.city"
                  keyObj="city"
                  inputFull
              />
              <q-separator class="m-4"/>
              <Lead_Fin_Field
                  v-for="(field, indexField) in lead.fields"
                  :prefix="`${field.name}:`"
                  :model="field"
                  inputFull
                  :whatsapp="field.name.toLowerCase().indexOf('телефон') >= 0"
                  :telegram="field.name.toLowerCase().indexOf('телефон') >= 0"
                  additionalField
                  :type="field.type"
                  :option="field.values"
                  keyObj="fields"
                  :index="indexField"
                  :fields="lead.fields"
              />
            </q-list>
            <q-list v-if="tab === 'fin'">
              <Lead_Fin_Field
                  prefix="Бюджет:"
                  suffix="руб."
                  iconName="attach_money"
                  :model="lead.budget"
                  keyObj="budget"
                  @updateField="updateField"
              />
              <Lead_Fin_Field
                  prefix="Долг:"
                  suffix="руб."
                  iconName="attach_money"
                  :model="lead.debt"
                  keyObj="debt"
                  @updateField="updateField"
              />
              <Lead_Fin_Field
                  v-if="!lead.prepay.cost"
                  prefix="Предоплата:"
                  suffix="руб."
                  iconName="attach_money"
                  :model="lead.prepay"
                  keyObj="prepay"
                  @updateField="updateField"
              />
              <add_pay
                  :model="lead.add_pay.length && lead.add_pay || [{date: '', value: '', date_2: ''}]"
                  :_id="lead._id"
                  @update-field="updateField"
              />
              <Lead_Fin_Field
                  prefix="Пол.решение:"
                  suffix="руб."
                  iconName="attach_money"
                  :model="lead.answer"
                  keyObj="answer"
                  @updateField="updateField"
              />
              <Lead_Fin_Field
                  prefix="Предл.сумма:"
                  suffix="руб."
                  iconName="attach_money"
                  :model="lead.proposed_amount"
                  keyObj="proposed_amount"
                  @updateField="updateField"
              />
            </q-list>
            <q-list v-if="tab === 'task'">
              <q-item clickable v-for="(task, index) in lead.task" class="flex column">
                <p class="absolute top-10 left-4">{{index + 1}}</p>
                <q-item class="grid grid-cols-2">
                  <q-chip dense :label="task.task"/>
                  <q-chip dense :label="`до ${formattedDate(task.taskDate)} ${task.taskHour}`"/>
                  <q-chip dense :label="task.statusTask && 'Задача выполнена' || 'Не выполнено'" :color="task.statusTask && 'blue' || 'pink'" :text-color="task.statusTask && 'white'"/>
                  <q-chip dense :label="task.from.username"/>
                </q-item>
                <q-separator/>
              </q-item>
            </q-list>
            <q-list v-if="tab === 'calendar'">
              <div class="flex flex-center mt-6">
                <q-date :locale="myLocale" :model-value="new Date()" color="info" />
              </div>
            </q-list>
            <q-list v-if="tab === 'docs'" style="max-width: 390px">
              <q-item clickable v-for="doc in lead.messages.filter(el => el.file)" class="flex column" :href="host + doc.file" target="_blank">
                <div class="inline-block truncate">{{doc.filename}}</div>
              </q-item>
            </q-list>
            <q-list v-if="tab === 'transfer'" style="max-width: 390px">
              <Transfer :_id="lead._id" @transferSendTask="sendMessage" :transfer="lead.transfer"/>
            </q-list>
            <div v-if="isAuth && tab === 'contacts'">
              <div class="text-h6 opacity-70 text-center mt-3">Индивидуальный доступ</div>
              <div class="flex justify-center">
                <q-btn v-if="!lead.unique_access" @click="generateUniqueAccessCode" label="Генерация кода" class="my-2">
                  <q-tooltip>Генерация уникального кода доступа.<br> Любой человек, используя код,<br> сможет просматривать эту страницу <br>PS: изменение/удаление не доступно</q-tooltip>
                </q-btn>
                <div v-else class="my-2">
                  <q-chip color="info" text-color="black" :label="lead.unique_access_code"/>
                  <q-btn @click="copyToClipboard" size="sm" color="green" label="копировать"/>
                  <q-btn @click="deleteUniqueAccessCode" icon="delete" color="red" round flat />
                </div>
              </div>
            </div>
          </q-scroll-area>
        </q-drawer>

        <q-page-container class="bg-grey-2">
          <div class="q-pa-md">

            <q-item v-if="securedMessage" class="secured-message shadow-2">
              <q-item-section side>
                <q-item-label>Закрепленно</q-item-label>
              </q-item-section>
              <q-item-section class="opacity-90">
                <q-item-label>
                  <div class="truncate">{{ securedMessage.message }}</div>
                  {{ securedMessage.task }}
                  до {{ formattedDate(securedMessage.taskDate) }} {{ securedMessage.taskHour }}
                </q-item-label>
              </q-item-section>
              <q-item-section>
                <q-btn size="sm" class="sm:w-full lg:w-1/2 ml-auto opacity-80 hover:opacity-100" color="black" label="перейти к сообщению" :href="`#${securedMessage.id}`"/>
              </q-item-section>
            </q-item>
            <q-chat-message v-if="lead.note" style="top: 50px; z-index: 10" :class="{'bg-blue-200 p-4 sticky':lead.note_secured}">
              <template v-slot:name>Инфо <span v-if="lead.note_secured" class="italic opacity-70">({{lead.note_secured && 'Закреплено' || ''}})</span></template>
              <template v-slot:avatar>
                <q-icon size="lg" name="smart_toy" class="mr-4"/>
              </template>

              <div class="flex justify-between no-wrap">
                <div>{{lead.note}}</div>
                <q-btn round flat icon="more_vert">
                  <q-menu auto-close>
                    <q-list dense>
                      <q-item v-if="!lead.note_secured" @click="useUpdateLead({_id: lead._id, key: 'note_secured', value: true, log: 'Закрепление примечания'}); lead.note_secured = true" clickable>
                        <q-item-section>Закрепить</q-item-section>
                      </q-item>
                      <q-item v-else @click="useUpdateLead({_id: lead._id, key: 'note_secured', value: false, log: 'Открепление примечания'}); lead.note_secured = false" clickable>
                        <q-item-section>Открепить</q-item-section>
                      </q-item>
                      <q-item v-if="roleMiddleware(['ADMIN'])" @click="deleteMessage(mess.id || mess.file)" clickable>
                        <q-item-section>Удалить</q-item-section>
                      </q-item>
                    </q-list>
                  </q-menu>
                </q-btn>
              </div>

            </q-chat-message>
            <q-chat-message
                v-for="(mess, i) in lead.messages"
                v-show="(mess.type !== 'Задача' && !mess.extension) || (mess.type === 'transfer' ||mess.type === 'Задача' || mess.extension)"
                :sent="mess.from?.username === user.username"
                :bg-color="mess.note && 'grey-7' || ((mess.statusTask && (mess.type === 'Задача'||mess.type === 'transfer')) && 'info' || 'green-4')"
                :text-color="mess.type === 'Задача' && 'black' || 'black'"
                :size="(screenWidth < 1000 && mess.message.length < 100) && '10' || '8'"
                class="mb-4"
                :class="{
                'w-full': true,
                'text-right':!mess.note && mess.from?.username === user.username,
                'pt-12':securedMessage && i === 0
              }"
            >
              <template v-slot:name>
                <p v-if="!mess.note" class="text-bold mb-2">
                  {{mess.from?.username}}
                  <span v-if="mess.owner && mess.owner.username !== mess.from.username" class="font-normal">от {{mess.owner.username}}</span>
                  <span class="font-normal"
                        :class="{'float-left':mess.from?.username === user.username, 'float-right':mess.from?.username !== user.username}"
                  >{{formattedDate(mess.date, true)}}</span>
                  <span
                      v-if="mess.secured"
                      :class="{
                      'float-left ml-4':mess.from?.username === user.username,
                      'ml-4':mess.from?.username === user.username,
                    }"
                      class="bg-pink-4 px-2 rounded"
                  >Закреплено</span>
                </p>
                <p class="text-bold mb-2" v-else>
                  Повторная заявка
                  <span class="font-normal float-right">{{formattedDate(mess.date, true)}}</span>
                </p>
              </template>
              <template v-slot:avatar>
                <q-icon v-if="!mess.note" size="lg" name="person" class="" :class="{'ml-4':mess.from?.username === user.username,'mr-4':mess.from?.username !== user.username}"/>
                <q-icon v-else size="lg" name="priority_high" class="ml-4"/>
              </template>
              <div
                  v-if="!mess.note"
                  :class="{'quickly-task':mess.quickly && mess.statusTask}"
                  :id="mess.id"
              >
                <div class="flex justify-between no-wrap items-start">
                  <div @click.stop v-if="mess.type === 'transfer'" class="text-left">
                    <div class="px-2">
                      <div>
                        <q-btn v-if="roleMiddleware(['ADMIN', 'LAWYER'])" label="Изменить" @click="isTransferModal = true" dense size="sm" color="blue" />
                        <div class="ml-4 text-h6">Договор</div>
                        <div class="px-2">
                          <p v-if="lead.transfer[0].check">{{lead.transfer[0]?.val}}</p>
                          <p v-if="lead.transfer[1].check">{{lead.transfer[1]?.val}}</p>
                          <p v-if="lead.transfer[2].check">{{lead.transfer[2]?.val}}</p>
                          <p v-if="lead.transfer[3].check">{{lead.transfer[3]?.val}}</p>
                          <p v-if="lead.transfer[4].check">{{lead.transfer[4]?.val}}</p>
                        </div>
                      </div>
                      <q-separator/>
                      <div>
                        <div class="ml-4 text-h6">Дело ведём в :</div>
                        <div class="px-2">
                          <p v-if="lead.transfer[5].check">{{lead.transfer[5]?.val}}</p>
                          <p v-if="lead.transfer[6].check">{{lead.transfer[6]?.val}}</p>
                          <p v-if="lead.transfer[7].check">{{lead.transfer[7]?.val}}</p>
                          <p v-if="lead.transfer[8].check">{{lead.transfer[8]?.val}}</p>
                          <p v-if="lead.transfer[9].check">{{lead.transfer[9]?.val}}</p>
                          <p v-if="lead.transfer[10].check">{{lead.transfer[10]?.val}}</p>
                        </div>
                      </div>
                      <q-separator/>
                      <div>
                        <div class="ml-4 text-h6">Подготовить</div>
                        <div class="px-2">
                          <p v-if="lead.transfer[44]?.check">{{lead.transfer[44]?.val}}</p>
                          <p v-if="lead.transfer[40]?.check">{{lead.transfer[40]?.val}}</p>
                          <p v-if="lead.transfer[11]?.check">{{lead.transfer[11]?.val}}</p>
                          <p v-if="lead.transfer[12]?.check">{{lead.transfer[12]?.val}}</p>
                          <p v-if="lead.transfer[42]?.check">{{lead.transfer[42]?.val}}</p>
                          <p v-if="lead.transfer[43]?.check">{{lead.transfer[43]?.val}}</p>
                          <p v-if="lead.transfer[13]?.check">{{lead.transfer[13]?.val}}</p>
                          <p v-if="lead.transfer[14]?.check">{{lead.transfer[14]?.val}}</p>
                          <p v-if="lead.transfer[15]?.check">{{lead.transfer[15]?.val}}</p>
                          <p v-if="lead.transfer[16]?.check">{{lead.transfer[16]?.val}}</p>
                          <p v-if="lead.transfer[17]?.check">{{lead.transfer[17]?.val}}</p>
                          <p v-if="lead.transfer[18]?.check">{{lead.transfer[18]?.val}}</p>
                          <p v-if="lead.transfer[19]?.check">{{lead.transfer[19]?.val}}</p>
                          <p v-if="lead.transfer[20]?.check">{{lead.transfer[20]?.val}}</p>
                          <p v-if="lead.transfer[21]?.check">{{lead.transfer[21]?.val}}</p>
                          <p v-if="lead.transfer[22]?.check">{{lead.transfer[22]?.val}}</p>
                          <p v-if="lead.transfer[23]?.check">{{lead.transfer[23]?.val}}</p>
                          <p v-if="lead.transfer[24]?.check">{{lead.transfer[24]?.val}}</p>
                        </div>
                      </div>
                      <q-separator/>
                      <div>
                        <div class="ml-4 text-h6">Когда суд</div>
                        <div class="px-2 my-4">
                          <p v-if="lead.transfer[35]?.val"  v-html="lead.transfer[35]?.val.replace(/\n/g, '<br>')"></p>
                        </div>
                      </div>
                      <q-separator/>
                      <div>
                        <div class="ml-4 text-h6">Матер.дела</div>
                        <div class="px-2">
                          <p v-if="lead.transfer[25]?.check">{{lead.transfer[25]?.val}}</p>
                          <p v-if="lead.transfer[26]?.check">{{lead.transfer[26]?.val}}</p>
                          <p v-if="lead.transfer[27]?.check">{{lead.transfer[27]?.val}}</p>
                          <p v-if="lead.transfer[28]?.check">{{lead.transfer[28]?.val}}</p>
                        </div>
                      </div>
                      <q-separator/>
                      <div>
                        <div class="ml-4 text-h6">Постановление</div>
                        <div class="px-2">
                          <p v-if="lead.transfer[29]?.check">{{lead.transfer[29]?.val}}</p>
                          <p v-if="lead.transfer[30]?.val" v-html="lead.transfer[30]?.val.replace(/\n/g, '<br>')"></p>
                          <p v-if="lead.transfer[31]?.check">{{lead.transfer[31]?.val}}</p>
                          <p v-if="lead.transfer[32]?.check">{{lead.transfer[32]?.val}}</p>
                        </div>
                      </div>
                      <q-separator/>
                      <div>
                        <div class="ml-4 text-h6">Описание</div>
                        <div class="px-2">
                          <p v-if="lead.transfer[33]?.val"  v-html="lead.transfer[33]?.val.replace(/\n/g, '<br>')"></p>
                          <p v-if="lead.transfer[34]?.check">{{lead.transfer[34]?.val}}</p>
                        </div>
                      </div>
                      <div>
                        <div class="ml-4 text-h6">Подготовлено</div>
                        <div class="px-2">
                          <p v-if="lead.transfer[41]?.check">{{lead.transfer[41]?.val}}</p>
                          <p v-if="lead.transfer[36]?.check">{{lead.transfer[36]?.val}}</p>
                          <p v-if="lead.transfer[37]?.check">{{lead.transfer[37]?.val}}</p>
                          <p v-if="lead.transfer[38]?.check">{{lead.transfer[38]?.val}}</p>
                          <p v-if="lead.transfer[39]?.check">{{lead.transfer[39]?.val}}</p>
                        </div>
                      </div>
                    </div>
                  </div>
                  <p v-else v-html="mess.message.replace(/\n/g, '<br>')" class="text-left"></p>
                  <q-btn round flat icon="more_vert">
                    <q-menu auto-close>
                      <q-list dense>
                        <q-item v-if="mess.secured" @click="unsecured(mess.id)" clickable>
                          <q-item-section>Открепить</q-item-section>
                        </q-item>
                        <q-item v-else @click="secureMessage(mess.id)" clickable>
                          <q-item-section>Закрепить</q-item-section>
                        </q-item>
                        <q-item v-if="roleMiddleware(['ADMIN'])" @click="deleteMessage(mess.id || mess.file)" clickable>
                          <q-item-section>Удалить</q-item-section>
                        </q-item>
                      </q-list>
                    </q-menu>
                  </q-btn>
                  <q-popup-edit v-if="roleMiddleware(['ADMIN'])" v-model="mess.message" v-slot="scope" >
                    <q-input v-model="scope.value" dense autofocus counter :type="scope.value.length > 20 && 'textarea'" />
                    <q-btn v-close-popup class="float-right" label="Сохранить" color="green" size="sm" @click="changeMessage(mess.id, scope.value)"/>
                  </q-popup-edit>
                </div>
                <q-separator v-if="mess.comments && mess.message" class="m-2"/>
                <p v-if="mess.comments">{{mess.comments}}</p>
                <q-separator v-if="mess.message && (mess.extension || mess.type === 'Задача' || mess.type === 'transfer')" class="m-2"/>
                <div class="flex align-items-center">
                  <q-separator v-if="mess.message && (mess.type === 'Задача' || mess.type === 'Файл')" class="m-2"/>
                  <q-chip :dense="screenWidth < 1500" v-if="mess.type === 'Задача' || mess.type === 'Файл' " :label="mess.type"/>
                  <q-chip :dense="screenWidth < 1500" v-if="mess.type === 'Задача'" :label="mess.task"/>
                  <q-chip
                      v-if="mess.type === 'transfer'||mess.type === 'Задача' && roleMiddleware(['ADMIN', 'LAWYER'])"
                      :dense="screenWidth < 1500"
                      :label="formattedDate(mess.taskDate) + ' ' + mess.taskHour"
                  >
                    <q-popup-edit :model-value="new Date()" v-model="mess.taskDate" v-slot="scope">
                      <div class="grid grid-cols-2 grid-rows-2 gap-2">
                        <q-date today-btn :locale="myLocale" class="row-span-3" :model-value="new Date()" v-model="scope.value"/>
                        <q-time :locale="myLocale" class="row-span-3" :model-value="new Date()" v-model="mess.taskHour"/>
                        <q-btn class="row-span-1" color="green" dense label="сохранить" v-close-popup @click="editTimeTask(scope.value, mess.taskHour, i)"/>
                      </div>
                    </q-popup-edit>
                  </q-chip>
                  <q-chip v-else-if="mess.type === 'transfer'||mess.type === 'Задача' && !roleMiddleware(['ADMIN'])" :dense="screenWidth < 1500" :label="`до ${formattedDate(mess.taskDate)} ${mess.taskHour}`"/>

                  <p v-if="mess.extension" class="inline-flex text-white ml-2" style="align-items: center">
                    <span class="w-1/2 text-sm">{{mess.filename}}</span>
                    <q-btn :href="host + mess.file" :dense="screenWidth < 1500" icon="download" size="sm" class="ml-2" round/>
                    <q-tooltip>
                      {{mess.filename}}
                    </q-tooltip>
                  </p>
                  <div v-if="isAuth" class="ml-auto">
                    <q-btn v-if="(mess.type === 'Задача'||mess.type === 'transfer') && mess.statusTask" @click="executeTask(mess)" dense class="float-right mx-1" color="green-5" size="12px" round icon="check">
                      <q-tooltip>Выполнить</q-tooltip>
                    </q-btn>
                    <q-btn v-if="(mess.type === 'Задача'||mess.type === 'transfer') && mess.statusTask" dense class="float-right mx-1" color="orange-3" text-color="black" size="12px" round icon="chat">
                      <q-tooltip>Выполнить с комментарием</q-tooltip>
                      <q-menu>
                        <div class="flex column p-4">
                          <textarea v-model="mess.comments" class="h-40 block mx-auto" style="width: 500px" />
                          <q-btn v-close-popup dense @click="executeTask(mess)" label="Выполнить задачу" color="green-7" class="mt-2" />
                        </div>
                      </q-menu>
                    </q-btn>
                    <q-btn v-if="(mess.type === 'Задача' || mess.type === 'transfer') && mess.statusTask" dense class="float-right mx-1" color="red-5" size="12px" round icon="swap_horiz">
                      <q-tooltip>Сменить ответственного</q-tooltip>
                      <q-menu>
                        <q-select
                            v-model="mess.from"
                            :model-value="mess.from.username"
                            dense
                            row-key="username"
                            option-label="username"
                            :options="options"
                            @filter="filterUsers"
                            map-options
                            use-input
                            autofocus
                        >
                          <template v-slot:option="{ itemProps, opt, selected, toggleOption }">
                            <q-item v-bind="itemProps">
                              <q-item-section @click="swapResponsibleTask(lead._id, opt.username, opt._id, i)" @update:model-value="selected">
                                <q-item-label v-html="opt.username" />
                              </q-item-section>
                            </q-item>
                          </template>
                          <template v-slot:no-option>
                            <q-item>
                              <q-item-section class="text-grey">
                                Нет результатов
                              </q-item-section>
                            </q-item>
                          </template>
                        </q-select>
                      </q-menu>
                    </q-btn>
                  </div>
                  <q-separator class="m-4"/>
                  <div v-if="(mess.type === 'Задача'||mess.type === 'transfer') && !mess.statusTask" class="flex">
                    <q-chip v-if="mess.type === 'Задача' && !mess.statusTask"
                            dense
                            class="float-right"
                            color="info"
                            text-color="black"
                            icon="check"
                            label="Задача выполнена!"
                    />
                    <q-chip color="info" text-color="black" dense :label="`Выполнено: ${mess.success}`" />
                  </div>
                  <q-img v-if="mess.extension && isImageMessage.includes(mess.extension)" :src="host + mess.file"/>
                </div>
              </div>
              <div v-else class="flex column text-white">
                <div>Имя: {{mess.note.name}}</div>
                <div>Город: {{mess.note.city}}</div>
                <div>Сайт: {{mess.note.website}}</div>
                <div>Дополнительно: {{mess.note.note}}</div>
              </div>
            </q-chat-message>
          </div>
        </q-page-container>

        <q-footer v-if="isAuth">
          <div v-if="1===2" style="position: absolute; bottom: calc(100% + 10px); right: 10px" class="flex row">
            <div v-for="(img, i) in files" :key="'file-'+i">
              <q-img v-if="img.toString().indexOf('data:application') < 0" class="border-black mx-2" :src="img.file" width="40px" />
              <div v-else class="flex column items-center">
                <q-icon size="lg" name="description"/>
                <span class="text-xs text-black">Документ</span>
              </div>
            </div>
          </div>
          <q-toolbar class="bg-grey-3 text-black row py-4">
            <q-btn @click="getTemplate" dense size="md" flat label="Шаблоны" class="q-mr-sm">
              <q-menu>
                <q-item :href="`https://wa.me/${lead.phone}?text=${temp.sms}`" target="_blank" clickable v-for="temp in template" :key="temp._id">
                  <q-item-section v-close-popup>{{temp.name}}</q-item-section>
                </q-item>
              </q-menu>
            </q-btn>
            <q-input
                rounded
                outlined
                dense
                class="WAL__field col-grow q-mr-sm"
                bg-color="white"
                v-model="message.message"
                placeholder="Введите сообщение"
                @keyup.enter="sendMessage"
                type="textarea"
                :input-style="{height: '40px'}"
                :loading="isLoadingButton"
            />
            <q-btn @click="sendMessage"
                   round
                   flat
                   icon="send"
                   title="Отправить"
                   :loading="isLoadingButton"
                   :disable="isLoadingButton"
            />
            <q-btn round flat icon="attach_file" title="Прикрепить">
              <q-badge v-if="message.task" floating color="red" rounded label="Задача" />
              <q-badge v-if="files" :style="{transform: message.task && 'translateY(-20px)'}" floating color="red" rounded label="Файл" />
              <q-menu auto-close :offset="[110, 0]">
                <q-list style="min-width: 150px">
                  <!--                <input type="file" @change="attachInput">-->
                  <DragFile is-drop :drop-flag="dropFlag" @propDragLeave="dragLeave" @on-drop="onDrop"/>
                  <q-item clickable @click="getTasks">
                    <q-item-section>Задача</q-item-section>
                  </q-item>
                </q-list>
              </q-menu>
            </q-btn>
          </q-toolbar>
        </q-footer>
      </q-layout>
      <Modal v-if="attach === 'task'" @close="attach = ''" no-border>
        <template v-slot:body>
          <div class="add-task">
            <div class="arena-date">
              <q-date v-model="message.taskDate"
                      :q-date="message.taskDate"
                      :model-value="message.taskDate"
                      today-btn
                      :locale="myLocale"
                      dark
              />
            </div>
            <div class="arena-time">
              <p class="white-text text-left mx-auto my-4">Время</p>
              <input v-model="message.taskHour" type="time"
                     min="00:00" max="24:00" width="50px" class="mb-4 mx-auto">
              <TaskSelected
                  :label-chip="message.task || 'Выбрать задачу'"
                  modelValue="Нажмите чтобы выбрать"
                  color-chip="green"
                  text-color-chip="white"
                  :model-select="message.task"
                  @selectTask="selectTask"
                  class="mt-6"
              />

              <UserSelected
                  :label-chip="message.from && message.from.username || 'Отвественный'"
                  :modelValue="message.from && message.from.username || 'Отвественный'"
                  color-chip="green"
                  text-color-chip="white"
                  :model-select="message.task"
                  @selectUser="selectResponsibleTask"
                  class="mb-6"
              />
              <q-btn label="СРОЧНО" :color="message.quickly && 'red'" @click="message.quickly = !message.quickly"/>
              <q-btn label="Закрепить" :color="message.secured && 'red'" @click="message.secured = !message.secured"/>
            </div>
            <div class="arena-btn">
              <q-btn
                  label="Ок"
                  color="green"
                  class="ml-auto mr-6 flex"
                  @click="attach = ''"
                  :disable="!message.task || !message.taskHour || !message.taskDate"
              />
            </div>
          </div>
        </template>
      </Modal>
      <Modal v-if="dialogSuccessMess" @close="dialogSuccessMess = null">
        <template v-slot:body>
          <div v-if="1===2" class="flex column">
            <p class="text-2xl mb-4 white-text">Выполнить задачу с комментарием</p>
            <q-btn label="Выполнить задачу" color="green-7" class="mt-2" />
          </div>
        </template>
      </Modal>
      <Modal v-if="historyModal" @close="historyModal = false">
        <template v-slot:body>
          <q-list>
            <q-item v-for="el in history">
              <div class="flex items-center justify-between w-full">
                <q-chip size="sm" :label="el.log"/> <q-icon name="east" class="mr-2"/> <span class="font-bold">{{el.user.username}}</span> {{formattedDate(el.createdAt, true)}} <q-btn flat label="Удалить" color="red" size="sm" />
              </div>
            </q-item>
          </q-list>
        </template>
      </Modal>
      <Modal v-if="isTransferModal" @close="isTransferModal = false">
        <template v-slot:body>
          <div class="text-left">
            <div class="px-2">
              <div>
                <div class="ml-4 text-h6">Договор</div>
                <div class="px-2">
                  <p>{{lead.transfer[0]?.val}}<input v-model="lead.transfer[0].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[1]?.val}}<input v-model="lead.transfer[1].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[2]?.val}}<input v-model="lead.transfer[2].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[3]?.val}}<input v-model="lead.transfer[3].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[4]?.val}}<input v-model="lead.transfer[4].check" type="checkbox" class="ml-2"></p>
                </div>
              </div>
              <q-separator/>
              <div>
                <div class="ml-4 text-h6">Дело ведём в :</div>
                <div class="px-2">
                  <p>{{lead.transfer[5]?.val}} <input v-model="lead.transfer[5].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[6]?.val}} <input v-model="lead.transfer[6].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[7]?.val}} <input v-model="lead.transfer[7].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[8]?.val}} <input v-model="lead.transfer[8].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[9]?.val}} <input v-model="lead.transfer[9].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[10]?.val}} <input v-model="lead.transfer[10].check" type="checkbox" class="ml-2"></p>
                </div>
              </div>
              <q-separator/>
              <div>
                <div class="ml-4 text-h6">Подготовить</div>
                <div class="px-2">
                  <p v-if="lead.transfer[40]">{{lead.transfer[40]?.val}} <input v-model="lead.transfer[40].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[11]?.val}} <input v-model="lead.transfer[11].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[12]?.val}} <input v-model="lead.transfer[12].check" type="checkbox" class="ml-2"></p>
                  <p v-if="lead.transfer[42]">{{lead.transfer[42]?.val}} <input v-model="lead.transfer[42].check" type="checkbox" class="ml-2"></p>
                  <p v-if="lead.transfer[43]">{{lead.transfer[43]?.val}} <input v-model="lead.transfer[43].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[13]?.val}} <input v-model="lead.transfer[13].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[14]?.val}} <input v-model="lead.transfer[14].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[15]?.val}} <input v-model="lead.transfer[15].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[16]?.val}} <input v-model="lead.transfer[16].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[17]?.val}} <input v-model="lead.transfer[17].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[18]?.val}} <input v-model="lead.transfer[18].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[19]?.val}} <input v-model="lead.transfer[19].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[20]?.val}} <input v-model="lead.transfer[20].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[21]?.val}} <input v-model="lead.transfer[21].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[22]?.val}} <input v-model="lead.transfer[22].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[23]?.val}} <input v-model="lead.transfer[23].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[24]?.val}} <input v-model="lead.transfer[24].check" type="checkbox" class="ml-2"></p>
                </div>
              </div>
              <q-separator/>
              <div>
                <div class="ml-4 text-h6">Когда суд</div>
                <div class="px-2 my-4">
                  <p v-if="lead.transfer[35]?.val"  v-html="lead.transfer[35]?.val.replace(/\n/g, '<br>')"></p>
                </div>
              </div>
              <q-separator/>
              <div>
                <div class="ml-4 text-h6">Матер.дела</div>
                <div class="px-2">
                  <p>{{lead.transfer[25]?.val}} <input v-model="lead.transfer[25].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[26]?.val}} <input v-model="lead.transfer[26].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[27]?.val}} <input v-model="lead.transfer[27].check" type="checkbox" class="ml-2"></p>
                  <p>{{lead.transfer[28]?.val}} <input v-model="lead.transfer[28].check" type="checkbox" class="ml-2"></p>
                </div>
              </div>
              <q-separator/>
              <div>
                <div class="ml-4 text-h6">Постановление</div>
                <div class="px-2">
                  <p >{{lead.transfer[29]?.val}} <input v-model="lead.transfer[29].check" type="checkbox" class="ml-2"></p>
                  <q-input v-if="lead.transfer[30]?.val" v-model="lead.transfer[30].val" type="textarea" :model-value="lead.transfer[30]?.val" dark/>
                  <p >{{lead.transfer[31]?.val}} <input v-model="lead.transfer[31].check" type="checkbox" class="ml-2"></p>
                  <p >{{lead.transfer[32]?.val}} <input v-model="lead.transfer[32].check" type="checkbox" class="ml-2"></p>
                </div>
              </div>
              <q-separator/>
              <div>
                <div class="ml-4 text-h6">Описание</div>
                <div class="px-2">
                  <q-input v-if="lead.transfer[33]?.val" v-model="lead.transfer[33].val" type="textarea" :model-value="lead.transfer[33]?.val" dark/>
                  <p>{{lead.transfer[34]?.val}} <input v-model="lead.transfer[34].check" type="checkbox" class="ml-2"></p>
                </div>
              </div>
              <div>
                <div class="ml-4 text-h6">Подготовлено</div>
                <div class="px-2">
                  <p v-if="lead.transfer[41]">{{lead.transfer[41].val}} <input v-model="lead.transfer[41].check" type="checkbox" class="ml-2"></p>
                  <p v-if="lead.transfer[36]">{{lead.transfer[36].val}} <input v-model="lead.transfer[36].check" type="checkbox" class="ml-2"></p>
                  <p v-if="lead.transfer[37]">{{lead.transfer[37].val}} <input v-model="lead.transfer[37].check" type="checkbox" class="ml-2"></p>
                  <p v-if="lead.transfer[38]">{{lead.transfer[38].val}} <input v-model="lead.transfer[38].check" type="checkbox" class="ml-2"></p>
                  <p v-if="lead.transfer[39]">{{lead.transfer[39].val}} <input v-model="lead.transfer[39].check" type="checkbox" class="ml-2"></p>
                </div>
              </div>
              <q-btn @click="updateTransfer" label="сохранить" class="my-4 w-full" color="green"/>
            </div>
          </div>
        </template>
      </Modal>
      <DragFile v-if="isAuth" :drop-flag="dropFlag" @propDragLeave="dragLeave" @on-drop="onDrop"/>
    </div>
    <div v-else-if="uniqueAccess">
      <div class="w-1/2 mx-auto pt-24">
        <q-input color="info" v-model="uniqueAccessCode" outlined label="Введите код доступа">
          <template v-slot:append>
            <q-btn @click="checkUniqueAccess" label="Войти"/>
          </template>
        </q-input>
      </div>
    </div>
    <div v-else>
      <p class="text-h2 text-center pt-24 fade-in">Нет доступа!</p>
    </div>
  </div>
</template>

<script>
import { useQuasar } from 'quasar'
import {ref, computed, onMounted} from 'vue'
import api from "../../API/api.js";
import {useStore} from "vuex";
import {useRoute, useRouter} from "vue-router";
import {useLogLead} from "../../components/useLogLead";
import formattedDate from "../../utils/formatDate";
import Lead_Fin_Field from "../../components/Lead_Fin_Field.vue";
import Modal from "../../components/Modal.vue";
import {useUpdateLead} from "../../components/useUpdateLead";
import {roleMiddleware} from "../../components/roleMiddleware";
import DragFile from "../../components/DragFile.vue";
import address from "../../API/address";
import UserSelected from "../../components/UserSelected.vue";
import Transfer from "./Transfer.vue";
import TaskSelected from "../../components/TaskSelected.vue";
import Add_pay from "./add_pay.vue";

let stringOptions = [].reduce((acc, opt) => {
  for (let i = 1; i <= 5; i++) {
    acc.push(opt + ' ' + i)
  }
  return acc
}, [])

export default {
  name: 'Lead',
  components: {Add_pay, TaskSelected, Transfer, UserSelected, DragFile, Modal, Lead_Fin_Field},
  setup () {
    const store = useStore()
    const route = useRoute();
    const router = useRouter();
    const user = store.state.user
    const isAuth = store.getters.isAuth

    const uniqueAccess = ref(false)
    const confirmTrueCode = ref(false)
    const uniqueAccessCode = ref('') //09412656470212588
    async function generateUniqueAccessCode() {
      const random = Math.random().toString().replace('.', '')
      useUpdateLead({_id, key: 'unique_access', value: true, log: 'Генерация кода уник.доступа'})
      lead.value.unique_access = true
      useUpdateLead({_id, key: 'unique_access_code', value: random})
      lead.value.unique_access_code = random
    }
    async function deleteUniqueAccessCode () {
      useUpdateLead({_id, key: 'unique_access', value: false, log: 'Удален код уник.доступа'})
      lead.value.unique_access = false
      useUpdateLead({_id, key: 'unique_access_code', value: ''})
      lead.value.unique_access_code = ''
    }
    async function checkUniqueAccess() {
      await api.checkUniqueAccess({_id, code: uniqueAccessCode.value})
          .then(async () => {
            confirmTrueCode.value = true
            await init()
          })
    }

    const lead = ref({})
    const securedMessage = ref({})
    async function unsecured (message_id) {
      await useUpdateLead({_id, key: 'message-secured', index: message_id, value: false})
        .then(() => {
          lead.value.messages.forEach(el => el.id === message_id && (el.secured = false))
          securedMessage.value = null
        })
    }
    async function secureMessage (message_id) {
      await useUpdateLead({_id, key: 'message-secured', index: message_id, value: true})
        .then(() => {
          lead.value.messages.forEach(el => {
            if (el.id === message_id) {
              el.secured = true
              securedMessage.value = el
            }
          })
        })
    }
    const isLoadingButton = ref(false)
    const regions = ref([])
    async function init () {
      await api.getLead({_id: route.params.id, user_id: user._id, code: uniqueAccessCode.value})
        .then(res => {
          if (!isAuth && !uniqueAccessCode.value.length) {
            uniqueAccess.value = res.data.unique_access
          } // если пользов. не авторизован но у лида есть неавторизованный доступ по коду
          else {
            lead.value = res.data.lead
            securedMessage.value = lead.value.messages.filter(el => el.secured).reverse()[0] // находим закрепленное сообщение
          }
          // stream('lead message', lead.value.messages);
          // scrollToBottom()
        })
      await api.getRegions().then(res => regions.value = res.data.region)
    }
    init()
    const _id = route.params.id

    const status = ref([])
    async function getStatus () {
      await api.getStatusLeads()
        .then(res => {
          status.value = [...res.data.statusLeads]
        })
    }
    const tasks = ref([])
    async function getTasks () {
      attach.value = 'task'
    }
    async function selectStatus (status) {
      await api.selectStatusLead({lead_id: _id, status_id: status._id})
        .then(() => {
          lead.value.status = status
          useLogLead(_id, 'Новый статус')// пользователь изменил статус
        })
    }

    async function toRegion(regionId, index) {
      await api.changeRegion({leadId: _id, regionId}).then(res => {
        if (res.data.status) {
          lead.value.region = regions.value[index]._id
        }
      })
      await selectStatus(status.value.find(el => el.name === 'Передан в регион'))
    }

    const message = ref({
      date: new Date(),
      from: {_id: user._id, username: user.username},
      owner: {_id: user._id, username: user.username},
      id: '',
      message: '',
      statusTask: true,
      success: "",
      task: "",
      taskDate: '',
      taskHour: "",
      type: 'Примечание',
    })
    function scrollToBottom() {
      // Прокручиваем элемент вниз
      let chatContainer = document.getElementsByClassName('scroll')[0]
      chatContainer.scrollTop += chatContainer.scrollHeight
      message.value = {
        date: new Date(),
        from: {_id: user._id, username: user.username},
        id: '',
        message: '',
        statusTask: true,
        success: "",
        task: "",
        taskDate: '',
        taskHour: "",
        type: 'Примечание',
      }
    }
    const attach = ref('')
    const files = ref(null)
    function onDrop (el) {
      files.value = el[0]
    }
    function attachInput (event) {
      files.value = event.target.files[0]
    }
    async function sendMessage (event) {
      if (event.shiftKey) {
        // Если нажат Shift, просто завершаем функцию, не делаем ничего
        return;
      }
      isLoadingButton.value = true
      let time = new Date(message.value.taskDate + ' ' + message.value.taskHour)
      message.value.taskDate = time
      const random = Math.random().toString().replace('.', '')
      if (files.value) await sendFile()
      else {
        if (message.value.task) message.value.type = 'Задача'
        else if (event?.name === 'transfer') {
          if (event.isFiles) {
            files.value = event.file
            return await sendFile({
              type: 'transfer',
              task: 'transfer',
              taskHour: event.time,
              taskDate: event.date,
              quickly: event.quickly,
              from: {_id: '642e89d86b66d8b6c7b11bc9', username: 'Елена Шуваева'},
              time: new Date(event.date + ' ' + message.value.taskHour)
            })
          } else {
            message.value.type = 'transfer'
            message.value.task = 'transfer'
            message.value.taskHour = event.time
            message.value.taskDate = event.date
            message.value.quickly = event.quickly
            message.value.from = {_id: '642e89d86b66d8b6c7b11bc9', username: 'Елена Шуваева'}
            time = new Date(event.date + ' ' + message.value.taskHour)
          }
        }
        message.value.id = random
        await api.sendMessage({_id, message: message.value}).then(() => {
          lead.value.messages.push(message.value)

          isLoadingButton.value = false
        })
        if (message.value.task) {
          const task = {
            id: random,
            task: message.value.task,
            taskDate: time,
            taskHour: message.value.taskHour,
            statusTask: message.value.statusTask,
            success: message.value.success,
            from: {_id: user._id, username: user.username},
          }
          message.value.taskFrom = {_id: user._id, username: user.username}
          await api.changeLeadTask({_id, task})
          lead.value.task.push(task)
        }
      }

      // Прокручиваем элемент вниз после добавления сообщения
      scrollToBottom();
    }
    async function changeMessage (message_id, newVal) {
      api.changeMessage({_id, message_id, newVal})
        .then(() => {
          lead.value.messages.filter(mess => mess.id === message_id && (mess.message = newVal))
        })
    }
    async function deleteMessage (message_id) {
      await useLogLead(_id, 'Удаление сообщения')
      await api.deleteMessage({_id: lead.value._id, message_id})
        .then(() => {
          useLogLead(_id, 'Удаление сообщений...', history)
          const indexToDelete = lead.value.messages.findIndex(obj => obj.id === message_id || obj.file === message_id); // Находим индекс объекта в массиве по его ID
          // Если индекс найден, удаляем объект из массива
          if (indexToDelete !== -1) {
            lead.value.messages.splice(indexToDelete, 1);
          } else {
            console.log('Объект с указанным ID не найден.');
          }
        })
        .catch(() => alert('Ошибка! Попробуйте снова'))
    }
    async function sendFile (data) {
      const random = Math.random().toString().replace('.', '')
      isLoadingButton.value = true
      const formData = new FormData()
      if (data) {
        formData.append('type', data.type)
        formData.append('task', data.task)
        formData.append('taskDate', data.taskDate)
        formData.append('taskHour', data.taskHour)
        formData.append('fromId', data.from._id)
        formData.append('fromUsername', data.from.username)
      } else {
        formData.append('fromId', message.value.from._id)
        formData.append('fromUsername', message.value.from.username)
        formData.append('type', message.value.task && 'Задача' || 'Файл')
        formData.append('task', message.value.task)
        formData.append('taskDate', new Date())
        formData.append('taskHour', message.value.taskHour)
      }
      formData.append('_id', _id)
      formData.append('message', message.value.message)
      formData.append('id', random)
      formData.append('ownerId', user._id)
      formData.append('ownerUsername', user.username)
      formData.append('statusTask', true)
      formData.append('success', '')
      formData.append('date', new Date())
      formData.append('file', files.value)
      await address().post('/send-file-lead', formData, {
        headers: {
          // eslint-disable-next-line
          'Authorization': `Bearer ${user.token}`,
          'Content-Type': 'multipart/form-data'
        }
      }).then(async () => {
        await init()
        files.value = null
        isLoadingButton.value = false
      })
    }

    async function deleteAllMessage () {
      await useUpdateLead({_id, key: 'messages', value: []})
      await useUpdateLead({_id, key: 'task', value: []})
      lead.value.messages.splice(0, lead.value.messages.length)
      lead.value.task.splice(0, lead.value.task.length)
      await useLogLead(_id, 'Удалены все сообщения и задачи')
    }

    const dialogSuccessMess = ref(0)
    async function executeTask(message) {
      const date = formattedDate(new Date(), true)
      const comments = message.comments
      await api.executeTaskLead({_id, id: message.id, date: date, comments})
        .then(res => {
          if (res.data.status) {
            lead.value.messages.filter(obj => {
              if (obj.id === message.id) {
                obj.statusTask = false
                obj.success = date
                obj.comments = comments
                dialogSuccessMess.value = 0
              }
            });
            message.value = {
              date: new Date(),
              from: {_id: user._id, username: user.username},
              id: '',
              message: '',
              statusTask: false,
              success: "",
              task: "",
              taskDate: new Date(),
              taskHour: "",
              type: 'Примечание'
            }
          }
        })
      await useLogLead(_id, 'Выполнение задачи')// пользователь подтвердил выполнение задачи лида
    }

    async function editTimeTask(date, time, messageIndex) {
      const timestamp = new Date(date).getTime() + 60*60*1000

      lead.value.messages[messageIndex].taskDate = timestamp
      lead.value.messages[messageIndex].taskHour = time

      const message = lead.value.messages[messageIndex]
      const message_id = message.id
      await useUpdateLead({_id, key: 'message', value: message, index: messageIndex})

      const taskIndex = lead.value.task.findIndex(el => el.id === message_id)
      const task = lead.value.task[taskIndex]
      task.taskDate = timestamp
      task.taskHour = time
      await useUpdateLead({_id, key: 'task', value: task, index: taskIndex})


      // await api.changeMessage({_id, message_id, message})
      // await useLogLead(_id, 'Изменение время задачи', history)
    }

    async function swapResponsibleTask (_id, username, user_id, messageIndex) {
      await api.swapTaskResponsible({_id, username, user_id, messageIndex})
    }

    const options = ref([])
    async function filterUsers (val, update, abort) {
      options.value.length || await api.getUsers().then(res => {
        stringOptions = res.data.users.map(obj => {
          const { username, _id } = obj; // Оставляем только свойства username и _id
          return { username, _id };
        });
      })
      update(() => {
        const needle = val.toLocaleLowerCase()
        options.value = stringOptions.filter(v => v.username.toLocaleLowerCase().indexOf(needle) > -1)
      })
    }

    const $q = useQuasar()

    const leftDrawerOpen = ref(false)
    const search = ref('')
    const currentConversationIndex = ref(0)


    const history = ref([])
    const historyModal = ref(false)
    async function getHistory () {
      historyModal.value = true
      await useLogLead(_id, 'Запрос истории лида', history)
    }


    const style = computed(() => ({
      height: $q.screen.height - 50 + 'px'
    }))
    const screenWidth = computed(() => $q.screen.width)

    function toggleLeftDrawer () {
      leftDrawerOpen.value = !leftDrawerOpen.value
    }

    function setCurrentConversation (index) {
      currentConversationIndex.value = index
    }

    const template = ref([])
    async function getTemplate () {
      await api.getTemplateSMS()
        .then(r => {
          template.value = r.data.template
        })
    }

    const selectedResponsible = ref({})
    async function selectResponsible (user) {
      selectedResponsible.value = user
      const select_id = [lead.value._id]
      await api.selectResponsibleLead({lead_id: select_id, user_id: user._id, username: user.username})
      lead.value.responsible.username = user.username
      lead.value.responsible._id = user._id
    }

    function copyToClipboard() {
      navigator.clipboard.writeText(lead.value.unique_access_code || uniqueAccessCode.value).then(function() {
        console.log('Текст скопирован успешно в буфер обмена');
      }).catch(function(err) {
        console.error('Не удалось скопировать текст: ', err);
      });
    }

    function updateField(newVal) {
      lead.value[`${newVal.key}`] = newVal.value
    }

    const isTransferModal = ref(false)
    async function updateTransfer() {
      await useUpdateLead({_id, key: 'transfer', value: lead.value.transfer})
      await useLogLead(_id, 'Изменение задачи "передача"')// пользователь изменил задачу лида
      isTransferModal.value = false
    }

    const dropFlag = ref(false)
    onMounted(() => {
      useLogLead(_id, 'Просмотр лида', history)
    })
    return {
      useUpdateLead,
      roleMiddleware,
      user,
      isAuth,
      lead,
      securedMessage,
      secureMessage,
      unsecured,
      isLoadingButton,
      regions,
      formattedDate,
      toRegion,

      selectedResponsible,
      selectResponsible,
      editTimeTask,

      status,
      statusLabel: computed(() => {
        if (lead.value.status && regions.value.length) {
          if (lead.value.status.name === 'Передан в регион') {
            const regionName = regions.value.find(el => el._id === lead.value.region);
            return `${lead.value.status.name} ${regionName.name}`;
          } else {
            return lead.value.status.name;
          }
        } else {
          return 'Статус';
        }
      }),
      getStatus,
      tasks,
      getTasks,
      selectStatus,
      deleteLead: () => {
        useLogLead(_id, 'Удаление лида', history)
        api.deleteLead({data: [_id], basket: false})
        router.replace({name: 'Index'})
      },
      deleteStatus: () => {
        lead.value.status = null
        useLogLead(_id, 'Удаление статуса', history)
        useUpdateLead({_id, key: 'status', value: null, log: 'Удаление статуса'})
      },

      leftDrawerOpen,
      search,
      message,
      isImageMessage: computed(() => ['jpg', 'JPG', 'png', 'jpeg']),
      attach,
      sendMessage,
      changeMessage,
      deleteMessage,
      selectResponsibleTask: function (el) {
        message.value.from.username = el.username
        message.value.from._id = el._id
      },
      selectTask: function (el) {
        message.value.task = el
      },
      files,
      deleteAllMessage,
      currentConversationIndex,
      host: computed(() => 'https://technik-crm.ru'),

      dialogSuccessMess,
      executeTask,

      history,
      historyModal,
      getHistory,

      options,
      filterUsers,
      swapResponsibleTask,

      setCurrentConversation,
      style,
      screenWidth,

      tab: ref('contacts'),

      toggleLeftDrawer,

      dropFlag,
      onDrop,
      attachInput,
      dragEnter: function () {
        dropFlag.value = true
      },
      dragOver: function () {
        // console.log(123)
        // dropFlag.value = false
      },
      dragLeave: function () {
        dropFlag.value = false
      },

      uniqueAccess,
      uniqueAccessCode,
      confirmTrueCode,
      generateUniqueAccessCode,
      deleteUniqueAccessCode,
      checkUniqueAccess,
      copyToClipboard,

      template,
      getTemplate,
      updateField,
      updateTransfer, isTransferModal,

      myLocale: {
        /* starting with Sunday */
        days: 'Воскресенье_Понедельник_Вторник_Среда_Четверг_Пятница_Суббота'.split('_'),
        daysShort: 'Вс_Пн_Вт_Ср_Чт_Пт_Сб'.split('_'),
        months: 'Январь_Февраль_Март_Апрель_Май_Июнь_Июль_Август_Сентябрь_Октябрь_Ноябрь_Декабрь'.split('_'),
        monthsShort: 'Янв_Фев_Мар_Апр_Май_Июн_Июл_Авг_Сен_Окт_Ноя_Дек'.split('_'),
        firstDayOfWeek: 1, // 0-6, 0 - Sunday, 1 Monday, ...
        format24h: true,
      }
    }
  }
}
</script>

<style lang="sass">
.secured-message
  position: fixed
  transform: translate(-20px, -16px)
  width: calc(100% - 386px)
  @media (max-width: 690px)
    width: 100%
  background-color: #ff952b
  color: black
  padding: 10px
  z-index: 100
.quickly-task
  z-index: 999
  animation: radial-pulse 1s infinite
  border-radius: 2%

.fade-in
  opacity: 0
  animation: fadeIn 1s ease-in-out forwards

  @keyframes fadeIn
    from
      opacity: 0
    to
      opacity: 1

/*создаем анимацию пульсации
@keyframes radial-pulse
  0%
    box-shadow: 0 0 0 0px rgb(179 27 0 / 50%)

  100%
    box-shadow: 0 0 0 40px rgb(255 0 0 / 0%)


.WAL
  width: 100%
  height: 100%
  padding-top: 20px
  padding-bottom: 20px

  &:before
    content: ''
    height: 127px
    position: fixed
    top: 0
    width: 100%

  &__layout
    margin: 0 auto
    z-index: 4000
    height: 100%
    width: 97%
    border-radius: 5px

  &__field.q-field--outlined .q-field__control:before
    border: none

  .q-drawer--standard
    .WAL__drawer-close
      display: none

@media (max-width: 850px)
  .WAL
    padding: 0
    &__layout
      width: 100%
      border-radius: 0

@media (min-width: 691px)
  .WAL
    &__drawer-open
      display: none

.conversation__summary
  margin-top: 4px

.conversation__more
  margin-top: 0!important
  font-size: 1.4rem
.add-task
  display: grid
  grid-template-columns: 1fr 1fr
  grid-template-rows: 1.7fr 0.3fr
  gap: 0 0
  grid-template-areas: "arena-date arena-time" "arena-date arena-btn"
  .arena-date
    grid-area: arena-date
    margin-right: 20px
  .arena-time
    grid-area: arena-time
    display: flex
    flex-direction: column
    margin-right: 20px
  .arena-btn
    grid-area: arena-btn
</style>
